/**********************************************************************************
 * ļ  key.c
 *     ɨ(ϵͳδʱSysTickʵɨʱ)
 * ʵƽ̨Sun_STM32Minϵͳ
 * Ӳӣ  PC10 -> KEY1  --> GND   
 *             PC11 -> KEY2 --> GMD      
 * 汾  ST_v3.5
 
 * Version    Date       Auther      Reversed History
  ----------------------------------------------------------------------------
  V1.0.0    2021-11-07  Lojam Fan  Fisrt Created 
  
 * (C) Sunshine Silicon Corporation 
 *  Website: http://www.sunsili.com  http://sunsili.taobao.com http://bbs.sunsili.com
 *  E-Mail : fan@sunsili.com
**********************************************************************************/

#include "key.h" 
#include "SysTick.h"

/*******************************************************************************
*   : Key_GPIO_Config
*     : KEY IO
*     : 
*     : 
*     :  
* ˵    : KEY(1~2)IOڷֱ:PC10,PC11
*******************************************************************************/
void Key_GPIO_Config(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;				//һGPIO_InitTypeDef͵GPIOʼṹ
	
	RCC_APB2PeriphClockCmd(KEY_RCC, ENABLE);			//ʹGPIOAʱ	
	
	GPIO_InitStructure.GPIO_Pin = KEY1 | KEY2;			//ѡҪʼGPIOA(PA15,PA14)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;		//ŹģʽΪ 		
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	//Ϊ50MHz
	GPIO_Init(KEY_PORT, &GPIO_InitStructure);			//ÿ⺯еGPIOʼʼGPIOAеPA15,PA14
}

/*******************************************************************************
*   : Key_Detection
*     : ¼
*     : GPIOxӦGPIOGPIO_PinӦ˿
*     : 
*     : KEY_DOWN(0):Ӧ£KEY_UP(1):Ӧû
* ˵    : KEY(1~2)IOڷֱ:PC10,PC11
*******************************************************************************/
u8 Key_Down_Detection(GPIO_TypeDef* GPIOx, u16 GPIO_Pin)
{			
	if(GPIO_ReadInputDataBit(GPIOx,GPIO_Pin) == KEY_DOWN)	//Ƿа 
	{	   
		Delay_nMs(10);	//ʱ		
		if(GPIO_ReadInputDataBit(GPIOx,GPIO_Pin) == KEY_DOWN)	//Ƿа   
		{	 
			while(GPIO_ReadInputDataBit(GPIOx,GPIO_Pin) == KEY_DOWN);	//ȴͷ  
			return KEY_DOWN;	 
		}
		else
		{
			return KEY_UP;
		}
	}
	else
	{
		return KEY_UP;
	}
}

/*******************************************************************************
*   : Key_Down_Scan
*     : ɨ
*     : 
*     : 0ûа£1
*     :  
* ˵    : KEY(1~2)IOڷֱ:PC10,PC11
*******************************************************************************/
u8 Key_Down_Scan(void)
{
	u16 downflag=0;
	u8 value=0;

  	downflag=GPIO_ReadInputData(KEY_PORT);
	if((downflag & 0x0c00) != 0x0c00)	//Ƿа 
	{	   
		Delay_nMs(10);	//ʱ	
		downflag = GPIO_ReadInputData(KEY_PORT) & 0x0c00;	
		if(downflag != 0x0c00 )	//Ƿа   
		{	 
			if((downflag & 0x0400) == 0) value |= 0x01;
			if((downflag & 0x0800) == 0) value |= 0x02; 	 
		}		
	}	

	return value;
}


/******************* (C) COPYRIGHT SUNSHINE SILICON  **************************
********************        END OF FILE key.c        *******************/
