/**********************************************************************************
* Sun STM32 mini Demo

*   Description
    
    PWM LED Breath Demo

    
* Version    Date       Auther      Reversed History
  ----------------------------------------------------------------------------
  V1.0.0    2021-11-07  Lojam Fan  Fisrt Created 
  
* (C) Sunshine Silicon Corporation 
*  Website: http://www.sunsili.com  http://sunsili.taobao.com http://bbs.sunsili.com
*  E-Mail : fan@sunsili.com

**********************************************************************************/

#include "stm32f10x.h"
#include "usart.h"
#include "SysTick.h"
#include "led.h"
#include "key.h"
#include <stdio.h>

u8 flag;
static u8 tim2_tick;
static u8 lum; //LED luminance

void Timer_Ch1_pwm_init(TIM_TypeDef* TIMx, uint16_t fre_hz, uint16_t dty);
void TIM_OC1_set_Pulse(TIM_TypeDef* TIMx, uint16_t fre_hz, uint16_t dty);
void Timer_Init_Config(TIM_TypeDef* TIMx, uint16_t fre_hz);
void RCC_Configuration(void);
void led_breath (void);



/*******************************************************************************
*   : main
*     : ûmainʼ
*     : 
*     : 
* ֵ  : int:ֵΪһ16λ
* ˵    : 
*******************************************************************************/
int main(void)
{
    u8 keyVal;
    RCC_Configuration();
    SysTick_Init_Config();
	USART1_Init_Config(115200);//USART1ʼ
    LED_GPIO_Config();
    Key_GPIO_Config();
    
    printf ("*===================================================*\n");
    printf ("*  *  Name: Sun STM32 mini Demo Code.    *************\n");
    printf ("*  * (C) Sunshine Silicon Corporation    *************\n");
    printf ("*  *  Website: http://www.sunsili.com    *************\n");
    printf ("*  *   E-Mail : fan@sunsili.com          *************\n");
    printf ("*===================================================*\n");
    printf ("* Sun STM32 mini PWM  Demo code .*\n");
    
    lum = 0;    //Start luminance 0
    flag = 1;   //Up count in 
    Timer_Ch1_pwm_init(TIM1, 10000, lum);
    Timer_Init_Config(TIM2, 100);	//Timer2ʼ 100Hz жƵʡ10msжһ
    
	while (1)
	{
        if(tim2_tick)
        {
            tim2_tick = 0;
            if(flag)
            {
               if(++lum >= 100)
               {
                   flag = 0;    //Down count in 
               }
//               LED4_ON();
            }
            else
            {                
                if(!lum)
                {
                    flag = 1;
                }
                else
                {
                    lum--;
                }
//                LED4_OFF();
            }
            TIM_OC1_set_Pulse(TIM1, 10000, 100-lum);
        }
	}
}

/*******************************************************************************
*   : Timer_Init_Config
*     : Timerʼ
*     : TIM_TypeDef* TIMx ʱ TIM1~8 
            uint16_t fre_hz ʱж Ƶ
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void Timer_Init_Config(TIM_TypeDef* TIMx, uint16_t fre_hz)
{
	TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	uint16_t TimerPeriod = 0;
    uint16_t TimerPrescaler = 71; //1Mhz Timer Conter frequency
    
    /* Compute the value to be set in ARR regiter to generate signal frequency at Fre_hz */
	TimerPeriod = (SystemCoreClock / fre_hz /( TimerPrescaler +1)) - 1;
	TIM_TimeBaseStructure.TIM_Period = TimerPeriod; //4999;					//һ¼װԶװؼĴڵֵ(5000Ϊ500ms)
	TIM_TimeBaseStructure.TIM_Prescaler = TimerPrescaler; //7199;					//ΪTIMxʱƵʳԤƵֵ(10KHzļƵ) 71
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//ʱӷָ:TDTS = TIM_CKD_DIV1
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;	//TIMϼģʽ
	TIM_TimeBaseInit(TIMx, &TIM_TimeBaseStructure);				//TIM_TimeBaseInitStructָĲʼTIMxʱλ

	/*жȼNVIC*/
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;				//TIM2ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	//ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;			//ȼ1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;				//ʹIRQͨ
	NVIC_Init(&NVIC_InitStructure); 							//ʼNVICĴ
	 
	TIM_ITConfig(TIMx, TIM_IT_Update, ENABLE ); 				//ʹTIMxָж
	
	TIM_Cmd(TIMx, ENABLE);  									//ʹTIMx
}	 

/*******************************************************************************
*   : TIM2_IRQHandler
*     : ʱ2жϷ
*     : 
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void TIM2_IRQHandler(void)   //TIM2жϷ
{    
	if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)  //TIM3жϷ
	{
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update  );  //TIMxжϱ־ 
		tim2_tick = 1;
	}
}


/*******************************************************************************
*   : Timer_Ch1_pwminit
*     : ʱ Ch1 pwm ʼ
*     : TIM_TypeDef* TIMx  ʱ TIM1~8 
            uint16_t fre_hz PWM Ƶ
            uint16_t dtyռձ 0-100
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void Timer_Ch1_pwm_init(TIM_TypeDef* TIMx, uint16_t fre_hz, uint16_t dty)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    TIM_OCInitTypeDef  TIM_OCInitStructure;
    uint16_t TimerPeriod = 0;
    uint16_t Channel1Pulse = 0;
    
    /* TIM1 Configuration ---------------------------------------------------
   Generate 7 PWM signals with 4 different duty cycles:
   TIM1CLK = SystemCoreClock, Prescaler = 0, TIM1 counter clock = SystemCoreClock
   SystemCoreClock is set to 72 MHz for Low-density, Medium-density, High-density
   and Connectivity line devices and to 24 MHz for Low-Density Value line and
   Medium-Density Value line devices
   
   The objective is to generate 7 PWM signal at 17.57 KHz:
     - TIM1_Period = (SystemCoreClock / 17570) - 1
   The channel 1 and channel 1N duty cycle is set to 50%
   The channel 2 and channel 2N duty cycle is set to 37.5%
   The channel 3 and channel 3N duty cycle is set to 25%
   The channel 4 duty cycle is set to 12.5%
   The Timer pulse is calculated as follows:
     - ChannelxPulse = DutyCycle * (TIM1_Period - 1) / 100
  ----------------------------------------------------------------------- */
  /* Compute the value to be set in ARR regiter to generate signal frequency at Fre_hz */
  TimerPeriod = (SystemCoreClock / fre_hz ) - 1;
  /* Compute CCR1 value to generate a duty cycle at duty for channel 1 and 1N */
  Channel1Pulse = (uint16_t) (((uint32_t) dty * (TimerPeriod - 1)) / 100);
  /* Compute CCR2 value to generate a duty cycle at 37.5%  for channel 2 and 2N */
//  Channel2Pulse = (uint16_t) (((uint32_t) 375 * (TimerPeriod - 1)) / 1000);
  /* Compute CCR3 value to generate a duty cycle at 25%  for channel 3 and 3N */
//  Channel3Pulse = (uint16_t) (((uint32_t) 25 * (TimerPeriod - 1)) / 100);
  /* Compute CCR4 value to generate a duty cycle at 12.5%  for channel 4 */
//  Channel4Pulse = (uint16_t) (((uint32_t) 125 * (TimerPeriod- 1)) / 1000);

  /* Time Base configuration */
  TIM_TimeBaseStructure.TIM_Prescaler = 0;
  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
  TIM_TimeBaseStructure.TIM_Period = TimerPeriod;
  TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;

  TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);

  /* Channel 1, 2,3 and 4 Configuration in PWM mode */
  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;
  TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
  TIM_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Enable;
  TIM_OCInitStructure.TIM_Pulse = Channel1Pulse;
  TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;
  TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_High;
  TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Set;
  TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;

  TIM_OC1Init(TIMx, &TIM_OCInitStructure);
  
  /* TIM1 counter enable */
  TIM_Cmd(TIMx, ENABLE);

  /* TIM1 Main Output Enable */
  TIM_CtrlPWMOutputs(TIMx, ENABLE);


}


/*******************************************************************************
*   : TIM_OC1_set_Pulse
*     : ʱ Ch1 pwm
*     : TIM_TypeDef* TIMx  ʱ TIM1~8 
            uint16_t prd  PWD
            uint16_t dtyռձ 0-100
*     : 
*     :  
* ˵    : 
*******************************************************************************/
void TIM_OC1_set_Pulse(TIM_TypeDef* TIMx, uint16_t fre_hz, uint16_t dty)
{
    uint16_t Channel1Pulse = 0;
    uint16_t TimerPeriod = 0;
    
     /* Compute the value to be set in ARR regiter to generate signal frequency at Fre_hz */
    TimerPeriod = (SystemCoreClock / fre_hz ) - 1;
    /* Compute CCR1 value to generate a duty cycle at duty for channel 1 and 1N */
    Channel1Pulse = (uint16_t) (((uint32_t) dty * (TimerPeriod - 1)) / 100);
    /* Set the Capture Compare Register value */
    TIMx->CCR1 = Channel1Pulse; 
}


/*******************************************************************************
*   : RCC_Configuration
*     : ϵͳʱΪ72MHZ(ԸҪ)
*     : 
*     : 
* ֵ  : 
* ˵    : STM32F107xSTM32F105xϵMCUSTM32F103xϵMCUʱͬ
*******************************************************************************/
void RCC_Configuration(void)
{
  ErrorStatus HSEStartUpStatus;               //ⲿʱ(HSE)Ĺ״̬
  
  RCC_DeInit();                               //ʱصļĴΪĬֵ
  RCC_HSEConfig(RCC_HSE_ON);                  //ⲿʱHSE 
  HSEStartUpStatus = RCC_WaitForHSEStartUp(); //ȴⲿʱ(HSE)ȶ

  if(SUCCESS == HSEStartUpStatus)             //ⲿʱѾȶ
  {
    /* Enable Prefetch Buffer */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable); //Flash
    /* Flash 2 wait state */
    FLASH_SetLatency(FLASH_Latency_2);
    
  
    RCC_HCLKConfig(RCC_SYSCLK_Div1); //AHBʱӵϵͳʱ(1Ƶ)/72MHZ
    RCC_PCLK2Config(RCC_HCLK_Div1);  //APB2ʱӺHCLKʱ/72MHz(Ϊ72MHz)
    RCC_PCLK1Config(RCC_HCLK_Div2);  //APB1ʱHCLKʱӵ2Ƶ/36MHz(Ϊ36MHz)
    
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); //PLLCLK = 8MHz * 9 = 72 MHz 


    RCC_PLLCmd(ENABLE); //ʹPLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET); //ȴPLLȶ

    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);          //ϵͳʱӵʱԴΪPLL

    while(RCC_GetSYSCLKSource() != 0x08);               //ϵͳʱԴǷPLL
    RCC_ClockSecuritySystemCmd(ENABLE);                 //ʹϵͳȫʱ 
    
    /* TIM1 GPIOx clock enable */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1 | RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD | RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO, ENABLE);
    /* TIM2 clock enable */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
  }
}


void led_breath (void)
{
    if(flag)
    {
       if(++lum >= 100)
       {
           flag = 0;    //Down count in 
       }
//               LED4_ON();
    }
    else
    {                
        if(!lum)
        {
            flag = 1;
        }
        else
        {
            lum--;
        }
//                LED4_OFF();
    }
    TIM_OC1_set_Pulse(TIM1, 10000, 100-lum);
}


/******************* (C) COPYRIGHT SUNSHINE SILICON  **************************
********************        END OF FILE main.c        *******************/